import java.io.*;
import java.util.*;


public class Grammar {
	public static void main(String[] args) throws FileNotFoundException
	{
		Scanner scan = new Scanner(new File("rules.txt"));
		Map<String, String> rules = fillMap(scan);
		System.out.println(rules.toString());
		generateSentence(rules);
	}
	public static Map<String, String > fillMap(Scanner scan)
	{
		HashMap<String ,String> rules = new HashMap<String, String>();
		while(scan.hasNextLine())
		{
			String line = scan.nextLine();
			StringTokenizer stringTokenizer = new StringTokenizer(line, "::=");
			while (stringTokenizer.hasMoreElements()) {
				rules.put(stringTokenizer.nextToken(), stringTokenizer.nextToken());
			}
		}
		
		return rules;
	}
	public static void generateSentence(Map<String, String> rules)
	{
		String rule1 = rules.get("<s>");
		StringTokenizer stringTokenizer = new StringTokenizer(rule1, "|");
		Random randomGenerator = new Random();
		
		while (stringTokenizer.hasMoreElements()) { 
			stringTokenizer = new StringTokenizer(stringTokenizer.nextToken(), " ");
			{
				String s = rules.get(stringTokenizer.nextToken());	//get the value of the token from the map
				if(!s.contains("<"))	//if it is a terminal
					System.out.print(s + " ");
				else
				{
					generateSentence(rules);
				}
			}
			
		}
	}
}
