import java.io.*;
import java.util.*;


public class Grammar {
	static Map<String, String> rules;
	public static void main(String[] args) throws FileNotFoundException
	{
		Scanner scan = new Scanner(new File("rules.txt"));
		rules = fillMap(scan);
		System.out.println(rules.toString());
		generateSentence("<s>");
	}
	public static Map<String, String > fillMap(Scanner scan)
	{
		HashMap<String ,String> rules = new HashMap<String, String>();
		while(scan.hasNextLine())
		{
			String line = scan.nextLine();
			StringTokenizer stringTokenizer = new StringTokenizer(line, "::=");
			while (stringTokenizer.hasMoreElements()) {
				rules.put(stringTokenizer.nextToken(), stringTokenizer.nextToken());
			}
		}
		
		return rules;
	}
	public static void generateSentence(String lhs)
	{
		String rhs = rules.get(lhs);
		String[] tokens = rhs.split("\\|");
		int random =  (int) (Math.random()*tokens.length);
		String s = tokens[random];
		if(!s.contains("<")) {
			System.out.print(s+" ");
		}
		else {
			String[] tokens2 = s.split(" ");
			for(int i=0; i<tokens2.length; i++) {
				generateSentence(tokens2[i]);
			}
		}
	}
}
